#include	<corlib.h>
#include	<string.h>
#include	<jfctype.h>
#include	<sys_doslib.h>
#include	<iocslib.h>
#include	"zmlib.h"
#include	"nsn.h"
#include	"com.h"
#include	"graph.h"
#include	"sub.h"

unsigned char	*getfullname( unsigned char *filename )
{
	static unsigned char	fullname[92];

	strcpy( fullname, path );
	strcat( fullname, filename );
	return fullname;
}

void	skipparam( TBOX *tb )
{
	unsigned char	*ptr= tb->ptr;

	while( *ptr != 0x1a ){
		if( *ptr == ';' ){
			ptr++;
			break;
		}
		ptr++;
	}
	tb->ptr= ptr;
}

unsigned char	*getparam( TBOX *tb )
{
	int	len= 127;
	static unsigned char	param[128];
	unsigned char	*wptr= param;		/* 擾 */
	unsigned char	*ptr= tb->ptr;

	while( *ptr == ' ' )	ptr++;
	while( *ptr != 0x1a && *ptr != ' ' && *ptr != ';' ){
		*wptr++= *ptr++;
		if( --len <= 0 )	break;
	}
	*wptr= NULL;
/*	if( !*param && *ptr == ';' )	ptr++;*/
	tb->ptr= ptr;

	return param;
}

static int gload( TBOX *tb )
{
	int	mode= 0;
	int	level= 0;
	int	x= 0;
	int	y= 0;
	unsigned char	comline[24];
	unsigned char	*param;

	*comline= NULL;
	do {
		param= getparam( tb );
		if( *param == '-' ){	/* IvV͂ */
			if( param[1] == 'd' ){
				mode= atoi2( param + 2 );
				if( mode > 2 || mode < 0 )	mode= 0;
			}else if( param[1] == 'l' ){
				level= atoi2( param + 2 );
			}else if( param[1] == 'x' ){
				x= atoi2( param + 2 );
			}else if( param[1] == 'y' ){
				y= atoi2( param + 2 );
			}else {
				skipparam( tb );
				return -2;
			}
		}else if( *param ){
			strcpy( comline, param );
		}
	} while( *param );

	if( *comline )	layman( mode, x, y, level, comline );
	return FALSE;
}

static int gclr( TBOX *tb )
{
	int	mode= 0;
	int	level= 0;
	unsigned int	color= 0;
	unsigned char	*param;

	bgcolor= 0;
	do {
		param= getparam( tb );
		if( *param == '-' ){	/* IvV͂ */
			if( param[1] == 'd' ){
				mode= atoi2( param + 2 );
				if( mode > 2 || mode < 0 )	mode= 0;
			}else if( param[1] == 'l' ){
				level= atoi2( param + 2 );
			}else {
				skipparam( tb );
				return -2;
			}
		}else if( *param ){
			color= atoi2( param );
		}
	} while( *param );

	if( !level ){
		bgcolor= color;
		bgcolor&= 0xffff;
	}
	layman( mode, 0, 0, level, NULL );
	return FALSE;
}

static int	gtone( TBOX *tb )
{
	int	bright= 16;
	unsigned char	*param;

	param= getparam( tb );
	if( *param ){
		bright= atoi2( param );
		if( bright < 0 ){
			bright= 0;
		}else if( bright > 32 ){
			bright= 32;
		}
	}
	skipparam( tb );

	tone64k( bright );		/* PxύX */
	return FALSE;
}

static int bgmplay( TBOX *tb )
{
	int	flag= FALSE;
	unsigned char	*param;

	do {
		param= getparam( tb );
		if( *param == '-' ){	/* IvV͂ */
			if( param[1] == 'b' ){
				flag= TRUE;
			}else {
				skipparam( tb );
				return -2;
			}
		}else if( *param && zmusic ){
			if( stricmp( bgmname, param ) || !bgopm ){
				if( bgopm= flag ){
					strcpy( bgmname, param );
				}
				param= getfullname( param );	/* tpX */
				if( WindowLoadExec( "mzp.x", param, NULL, NULL ) ){
					return -5;
				}
			}
		}
	} while( *param );

	return TRUE;
}

static int bgmstop( TBOX *tb )
{
	int	fade= -1;
	unsigned char	*param;

	do {
		param= getparam( tb );
		if( *param == '-' ){	/* IvV͂ */
			if( param[1] == 'f' ){
				fade= atoi2( param + 2 );
			}else {
				skipparam( tb );
				return -2;
			}
		}
	} while( *param );

	if( zmusic ){
		bgopm= FALSE;
		if( fade < 0 ){
			zm_stop_all();
		}else {
			zm_fadeout( fade );
		}
	}
	return FALSE;
}

static int adpcmout( TBOX *tb )
{
	unsigned char	*param;

	param= getparam( tb );	/* Ȃ */

	if( *param ){
		if( !stricmp( param, pcmdata.name ) ){
			ADPCMAOT( pcmdata.adrs, 0x0403, pcmdata.tblsize );
		}else {
			if( (int)(pcmdata.adrs) ){
				MFREE( (int)(pcmdata.adrs) );
				pcmdata.adrs= NULL;
				pcmdata.name[0]= NULL;
			}
			strcpy( pcmdata.name, param );
			param= getfullname( param );	/* tpX */
			if( !pcmout( &pcmdata, param ) ){
				pcmdata.name[0]= NULL;
			}
		}
	}
	skipparam( tb );

	return FALSE;
}

static int adpcmstop( TBOX *tb )
{
	skipparam( tb );
	if( (int)(pcmdata.adrs) )	pcmstop();

	return FALSE;
}

int gotolabel( TBOX *tb )
{
	unsigned char	**label= labeltbl;
	unsigned char	*param;
	unsigned char	*lptr, *pptr;
	int	flag;

	param= getparam( tb );	/* Ȃ */

	if( *param ){
		while( *label ){
			pptr= param;
			lptr= *label;
			flag= TRUE;
			while( *pptr ){
				if( *pptr != *lptr ){
					flag= FALSE;
					break;
				}
				pptr++;
				lptr++;
			}
			if( flag ){
				if( debug ){
					ConsoleOpen();
					ConsolePrintf( "goto %s\n", param );
				}
				tb->ptr= lptr;
				store();
				return FALSE;
			}
			label++;
		}
		if( debug ){
			return -7;
		}
	}else if( debug ){
		return -7;
	}
	skipparam( tb );
	return FALSE;
}

int	setexpr( TBOX *tb )
{
	unsigned char	name[20];
	unsigned char	*wptr= name;
	int	flag= FALSE;

	while( *(tb->ptr) == ' ' )	tb->ptr++;
	while( 1 ){
		if( *(tb->ptr) == 0x1a || *(tb->ptr) == ';' ){
			skipparam( tb );
			return -4;
		}else if( *(tb->ptr) == '=' ){
			flag= TRUE;
			break;
		}
		*wptr++= *(tb->ptr++);
	}
	*wptr= NULL;
	while( *(tb->ptr) != '=' ){
		if( *(tb->ptr) == 0x1a || *(tb->ptr) == ';' ){
			skipparam( tb );
			return -4;
		}
		tb->ptr++;
	}
	tb->ptr++;

	if( !expr( tb, &flag ) ){
		if( debug ){
			return -4;
		}else {
			skipparam( tb );
		}
	}
/*
	ConsoleOpen();
	ConsolePrintf( "var : %d\n", flag );
*/
	if( !setvar( name, flag ) )	return -5;
	return FALSE;
}

static int	nsnexit( TBOX *tb )
{
	WindowSendSignal( WindowProcessID, SignalKill, 0 );
	return TRUE;
}


static int	echo( TBOX *tb )
{
		tb->echo= TRUE;
		return FALSE;
}

int	com( TBOX *tb )
{						/* ߎo */
	COMMAND	*com= comtbl;
	unsigned char	*comstr;

	if( iskanji( *(tb->ptr) ) ){
		if( debug )	return -1;
		return echo( tb );
	}
	comstr= getparam( tb );

	if( !*comstr || *comstr == ':' ){
		return FALSE;
	}

	while( com->name ){	/* \Əƍ */
		if( !strcmpi( com->name, comstr ) ){
			return com->func( tb );
		}
		com++;
	}
	return -1;
}
