#include	<corlib.h>
#include	"nsn.h"
#include	"sub.h"


char	*getnum( char *p, int *num )
{
	char	atoibuf[32];
	char	*ap= atoibuf;

	do {
		*ap++= *p++;			/* ςł */
	} while	( *p >= '0' && *p <= '9' );
	*ap= NULL;

	*num= atoi2( atoibuf );

	return p;

}

int	*calc( int i, int *ip, int argc )
{
	int	arg1, arg2;

	if( i <= 1 ){
		if( !argc  )	return NULL;
		arg1= *--ip;
	}else {
		if( argc < 2 )	return NULL;
		arg1= *--ip;
		arg2= *--ip;
	}

	switch( i ){
	case  0:	/* ~(bit not) */
		*ip++= ~arg1;
		break;
	case  1:	/* !(logical not) */
		*ip++= (arg1)?0:1;
		break;
	case  4:	/* =(equal) */
		*ip++= (arg2 == arg1);
		break;
	case  5:	/* <(less) */
		*ip++= (arg2 < arg1);
		break;
	case  6:	/* >(greater) */
		*ip++= (arg2 > arg1);
		break;
	case  7:	/* -(sub) */
		*ip++= arg2 - arg1;
		break;
	case  8:	/* +(add) */
		*ip++= arg2 + arg1;
		break;
	case  9:	/* *(multiply) */
		*ip++= arg2 * arg1;
		break;
	case 10:	/* /(divide) */
		if( !arg1 ){
			*ip++= 0;
		}else {
			*ip++= arg2 / arg1;
		}
		break;
	case 11:	/* %(mod) */
		if( !arg1 ){
			ip++;
		}else {
			*ip++= arg2 % arg1;
		}
		break;
	case 12:	/* &(bit and) */
		*ip++= (arg2 & arg1);
		break;
	case 13:	/* |(bit or) */
		*ip++= (arg2 | arg1);
		break;
	case 14:	/* ^(xor) */
		*ip++= (arg2 ^ arg1);
		break;
	case 15:	/* Not equal(!=) */
		*ip++= (arg2 != arg1);
		break;
	case 16:	/* Less or equal(<=) */
		*ip++= (arg2 <= arg1);
		break;
	case 17:	/* Greater or equal(>=) */
		*ip++= (arg2 >= arg1);
		break;
	case 18:	/* Minus(-) */
		*ip++= -arg1;
		break;
	case 19:	/* logical And(&&) */
		*ip++= (arg2 && arg1);
		break;
	case 20:	/* logical Or(||) */
		*ip++= (arg2 || arg1);
		break;
	case 21:	/* Right shirt */
		*ip++= (arg2 >> arg1);
		break;
	case 22:	/* left Shift */
		*ip++= (arg2 << arg1);
		break;
	default:
		return NULL;
	}
	return ip;
}


unsigned char	*i_polish( char *buf, int *istack, int *status )
{
	int	*ip= istack;
	int	i;
	int	numeric= FALSE;
	char	cstack[32];
	char	*cp= cstack + 31;		/* ZqX^bN */
	char	*p= buf;
	char	code[]= "~!()=<>-+*/%&|~nlgmaors";
	char	order[]= {
						14,14, 0, 0, 9,10,10,12,12,13,13,13,
						 8, 6, 7, 9,10,10,14, 5, 4,11,11,-1
					};

	*cp= -1;						/* X^bN̒ */

	while( 1 ){

		while( *p == ' ' ){			/* 󔒂XLbv */
			p++;
		}
									/* I */
		if( *p == ';' || *p == '{' || *p == 0x1a )	break;

		if( *p >= '0' && *p <= '9' ){
			if( numeric ){			/* l̘A̓G[ */
				return p;
			}else {
				numeric= TRUE;
			}
			p= getnum( p, ip );		/* lX^bNɐς */
			ip++;
			continue;
		}

		if( *p == '$' ){
			if( numeric ){			/* l̘A̓G[ */
				return p;
			}else {
				numeric= TRUE;
			}
			p= getvar( p + 1, ip );
			ip++;
			continue;
		}

		for( i= 0; code[i]; i++ ){	/* Zq}b`O */
			if( *p == code[i] ){
				break;
			}
		}
		p++;
		switch( i ){
		case  0:	/* ~ */
			break;
		case  1:	/* ! */
			if( *p == '=' ){
				i= 15;
				p++;
			}
			break;
		case  2:	/* ( */
			if( numeric ){			/* l̒̓G[ */
				return p;
			}
			*--cp= i;				/* ZqX^bNɐς */
			continue;
		case  3:	/* ) */
			if( !numeric ){			/* ( OȂG[ */
				return p;
			}
			while( *cp != 2 ){		/* ()̒|o */
				if( *cp < 0 )	return p;	/* ( Ȃ */
				if( !(ip= calc( *cp++, ip, ip - istack ) ) ){;
					return p;
				}
			}
			cp++;					/* (  */
			continue;
		case  4:	/* = */
			if( *p == '=' ){
				p++;
			}
			break;
		case  5:	/* < */
			if( *p == '=' ){
				i= 16;
				p++;
			}else if( *p == '>' ){
				i= 15;
				p++;
			}else if( *p == '<' ){
				i= 22;
				p++;
			}
			break;
		case  6:	/* > */
			if( *p == '=' ){
				i= 17;
				p++;
			}else if( *p == '>' ){
				i= 21;
				p++;
			}
			break;
		case  7:	/* - */
			if( !numeric ){
				i= 18;
			}
			break;
		case  8:	/* + */
		case  9:	/* * */
		case 10:	/* / */
		case 11:	/* % */
			break;
		case 12:	/* & */
			if( *p == '&' ){
				i= 19;
				p++;
			}
			break;
		case 13:	/* | */
			if( *p == '|' ){
				i= 20;
				p++;
			}
			break;
		case 14:	/* ^ */
			break;
		default:				/* `ZqȂG[ */
			return p;
		}

		if( !numeric && i <= 1 ){
			return p;			/* Zq̘A */
		}else {
			numeric= FALSE;		/* Zq */
		}
		while(  *cp >= 0 && order[i] <= order[*cp] ){
								/* D揇ʂ̍Zq̒ǂo */
			if( !( ip= calc( *cp++, ip, ip - istack ) ) ){;
				return p;
			}
		}
		*--cp= i;				/* ZqX^bNɐς */
	}

	while( *cp >= 0 ){			/* ZqX^bN̎c|o */
		if( !(ip= calc( *cp++, ip, ip - istack ) ) ){
			return p;
		}
	}
/*
	if( ip - istack != 1 ){
		*status= -1;
	}else {
		*status= 1;
	}
*/
	*status= ip - istack;
	return p;
}


int	expr( TBOX *tb, int *var )
{
	int	istack[32];
	int	status= FALSE;

	tb->ptr= i_polish( tb->ptr, istack, &status );	/* t|[h */

	if( debug ){
		ConsoleOpen();
		ConsolePrintf( "expr : %d\n", *istack );
	}

	if( status ){
		*var= *istack;
		return TRUE;
	}else {
		*var= 0;
		return FALSE;
	}
}
