/* Sound Novel test	for Ko-window	*/
/*		1999 Shinichi Honma (rick)	*/

#include	<mm_alloc.h>	/* gq[vCu */
#include	<corlib.h>
#include	<winop.h>
#include	<string.h>
#include	<jfctype.h>		/* XCLIBp */
#include	<sys_doslib.h>	/* XCLIBp */
#include	<dbslib.h>		/* jel\[XǗp */
#include	"zmlib.h"		/* ZMUSICp (thanks) */
#include	"nsn.h"
#include	"graph.h"
#include	"sub.h"

int	WindowHeapSize= 64 * 1024;

static DefGraphic	gra;
TBOX	tbox;
static unsigned char
	KINSOKU[]= "ABvxHIjpnhfCD@BDFHb";

static int kinsokuchk( TBOX *tb )
{
	int	flag= FALSE;
	unsigned char	*chr, *kin;

	chr= tb->ptr + 2;
	while( !iskanji( *chr ) ){
		if( *chr == 0x1a || *chr == ';' ){
			return FALSE;
		}
		chr++;
	}

	kin= KINSOKU;
	while( *kin ){
		if( *chr == *kin && *(chr + 1) == *(kin + 1 ) ){
			flag= TRUE;
			break;
		}
		kin+= 2;
	}
	if( !flag )	return FALSE;

	chr= tb->str;
	kin= KINSOKU;
	while( *kin ){
		if( *chr == *kin && *(chr + 1) == *(kin + 1 ) ){
			return FALSE;
		}
		kin+= 2;
	}
	return TRUE;
}

static int	alloc_his( TBOX *tb )	/* qXgobt@m */
{
	linepack	*newlp;
	int	i;

	newlp= malloc( sizeof( linepack ) * tb->max * 2 );
	if( !newlp ){
		ConsoleOpen();
		ConsolePrint( "nsn : ܂\n" );
		return FALSE;
	}
	tb->max*= 2;
	if( tb->lp ){					/* ̃qXgRs[ */
		for( i= 0; i < tb->lines; i++ ){
			newlp[i]= tb->lp[i];
		}
		free( tb->lp );
	}
	tb->lp= newlp;
	return TRUE;
}

static void	hisClose( TBOX	*tb )	/* qXgobt@ */
{
	int	i;

	if( tb->lp ){
		for( i= 0; i < tb->lines; i++ ){
			free( tb->lp[i].buf );
		}
		free( tb->lp );
		tb->lp= NULL;
	}
	tb->lines= 0;
	tb->max= 128;
	tb->vy= 0;
}

static void	TxtClose( TBOX *tb )
{
	if( tb->buf ){			/* eLXgobt@ */
		MFREE( (int)(tb->buf) );
	}
}

static unsigned char *TxtOpen( unsigned char *fname )
{
	unsigned char	**label= labeltbl;
	unsigned char	*fbuf, *rptr, *wptr;
	int	fn, fsize;

	strcpy( nsnfile, fname );

	ConsoleOpen();
	if( (fn= OPEN( getfullname( fname ), 0 ) ) < 0 ){
		ConsolePrintf( "nsn : %s cannot open\n", fname );
		return NULL;
	}

	fsize= SEEK( fn, 0, 2 );
	SEEK( fn, 0, 0 );
	if( (int)( fbuf= (unsigned char*)MALLOC2( 0, fsize + 2 ) ) < 0 ){
		CLOSE( fn );
		ConsolePrintf( "nsn : ܂\n" );
		return NULL;
	}
	READ( fn, fbuf + 1, fsize );
	CLOSE( fn );

	*fbuf= ' ';						/* t@C擪xop̍׍H */
	*( fbuf + fsize + 1 )= 0x1a;	/* EOFt */
	rptr= fbuf;
	wptr= fbuf;
	while( *rptr != 0x1a ){
		if( *rptr <= ' ' ){		/* L͂܂Ƃ߂ĂP̋󔒂 */
			do {
				rptr++;
			} while( *rptr != 0x1a && *rptr <= ' ' );
			*wptr++= ' ';
		}else if( *rptr == ':' ){	/* x */
			unsigned char	*bptr= wptr++;
			while( *(--bptr) != ' ' ){
				*(bptr + 1)= *bptr;
			}
			*++bptr= ':';
			*label++= bptr + 1;
			rptr++;
			*wptr++= ' ';
		}else if( *rptr == '#' ){
			do {
				rptr++;
			} while( *rptr != 0x1a && *rptr != '\n' );
		}else {
			*wptr++= *rptr++;
		}
	}
	*wptr++= 0x1a;

	SETBLOCK( fbuf, (int)(wptr - fbuf) );
	*label= NULL;

	if( debug ){
		fn= CREATE( getfullname( "dump" ), 0x20 );
		if( fn >= 0 ){
			WRITE( fn, fbuf, (int)(wptr - fbuf ) );
			CLOSE( fn );
		}
	}
	return fbuf;
}


static void	revive( TBOX *tb )
{
	DrawBuf	dbuf[32], *dp= dbuf;
	int	ymin, ymax, j, k;

	ymax= tb->vy;
	ymin= ymax - tb->y;

	DrawSetClear( dp++, 2 );			/* ʃNA */

	for( j= 0; j < tb->lines; j++ ){	/* \͈͂܂ŃXLbv */
		if( (tb->lp[j]).y >= ymin - FONT_Y ){
			break;
		}
	}

	if( tb->len ){
		DrawSetSymbol( dp++, tb->top, tb->y, tb->str, tb->attr, FONT_Y );
	}
	for( k= 32 - 2; (tb->lp[j]).y <= ymax && j < tb->lines; j++ ){
		DrawSetSymbol( dp++, (tb->lp[j]).x, (tb->lp[j]).y - ymin,
						(tb->lp[j]).buf, (tb->lp[j]).attr, FONT_Y );

		if( --k <= 0 ){		/* dbuf g؂` */
			WindowDraw( tb->twp, dbuf, dp - dbuf );
			dp= dbuf;
			k= 32;
		}
	}
	if( k < 32 )	WindowDraw( tb->twp, dbuf, dp - dbuf );
}

static int	renew_his( TBOX *tb )
{
	int ret;

	hisClose( tb );
	ret= alloc_his( tb );
	if( !ret ){
		WindowSendSignal( WindowProcessID, SignalKill, 0 );
	}
	return ret;
}

static void regist( TBOX *tb )
{
	unsigned char	*ptr;

	if( !(tb->len) )	return;
	ptr= malloc( ++(tb->len) );
	if( !ptr ){
		if( !renew_his( tb ) )	return;
		ptr= malloc( ++(tb->len) );
		if( !ptr ){
			WindowSendSignal( WindowProcessID, SignalKill, 0 );
		}
		return;
	}
	if( tb->lines >= tb->max ){		/* s|C^tȂ */
		if( !alloc_his( tb ) ){	/* mۂ */
			if( !renew_his( tb ) )	return;
		}
	}
	strcpy( ptr, tb->str );
	(tb->lp[tb->lines]).x= tb->top;
	(tb->lp[tb->lines]).y= tb->vy;
	(tb->lp[tb->lines]).attr= tb->attr;
	(tb->lp[tb->lines++]).buf= ptr;	/* qXgɓo^ */
	tb->top= tb->x;
	tb->len= 0;
	*(tb->str)= NULL;
}

static void	nextline( TBOX *tb, int leftline )
{								/* s */
	regist( tb );
	tb->top= 0;
	tb->x= 0;
	tb->vy+= FONT_Z;
	tb->y+= FONT_Z;
	if( leftline >= 0 || tb->y >= WIN_V - FONT_Z ){
		tb->y= abs( leftline ) * FONT_Z;
		revive( tb );
	}
}

static int	charput( TBOX *tb )
{
	DrawBuf	dbuf[1];
	static int	loop= FALSE;
	unsigned char	*ptr;
	int	ret;

	while( !tb->echo ){
		while( *(tb->ptr) == ' ' || *(tb->ptr) == ';' ){
			tb->ptr++;
		}
		if( *(tb->ptr) == 0x1a ){
			tb->echo= TRUE;
			return loop;
		}
		ret= com( tb );
		if( ret > 0 )	return loop;
		if( debug && ret < 0 )	return ret;
	}
	while( !iskanji( *(tb->ptr) ) ){	/* shift-JIS `FbN */
		switch( *(tb->ptr) ){
		case ';':						/* echoI */
			tb->echo= FALSE;
			if( loop )	loop= FALSE;
			tb->ptr++;
		case 0x1a:						/* EOF */
			return loop;
		case 'b':						/* bŉs */
		case 'B':
			nextline( tb, -2 );
			tb->ptr++;
			return loop;
		case 'c':
		case 'C':
			nextline( tb, 0 );
			break;
		case 'h':
		case 'H':
			if( tb->ExecTime > 1 ){
				tb->ExecTime= 1;
			}else {
				tb->ExecTime= 4;
			}
			break;
		case 'm':
		case 'M':
			loop= (loop)? FALSE:TRUE;
			break;
		case 'p':
		case 'P':
			tb->pause= tb->attr;
			if( loop )	loop= FALSE;
			break;
		case 'r':
		case 'R':
			nextline( tb, 2 );
			break;
		case 's':
		case 'S':
			if( tb->ExecTime < 10 ){
				tb->ExecTime= 13;
			}else {
				tb->ExecTime= 4;
			}
			break;
		case 't':
		case 'T':
			if( tb->ExecTime < 50 ){
				tb->oldtime= tb->ExecTime;
				tb->ExecTime= 50;
			}else {
				tb->ExecTime= tb->oldtime;
				tb->ptr++;
			}
			return loop;
		case 'w':
		case 'W':
			regist( tb );
			tb->attr^= AttrHighLight;
			break;
		case 'y':
		case 'Y':
			regist( tb );
			tb->attr^= AttrUnderLine;
			break;
		case ' ':
			break;
		default:
			if( debug ){
				tb->ptr++;
				return -3;
			}
			break;
		}
		tb->ptr++;
		if( tb->pause )	break;
	}

	if( tb->x >= WIN_H - FONT_X ){		/* s͂ݏo */
		nextline( tb, -2 );
	}else if( tb->x == 20 * FONT_Y ){
		if( kinsokuchk( tb ) ){
			nextline( tb, -2 );
		}
	}

	if( tb->pause ){
		WindowSetEventAttr( tb->twp, noINTattr );
		regist( tb );
		tb->attr= 33;
		ptr= tb->str;
		*ptr++= 0x81;
		*ptr++= 0xa5;
	}else {
		ptr= tb->str + tb->len;
		*ptr++= *(tb->ptr++);
		*ptr++= *(tb->ptr++);
	}
	tb->len+= 2;
	*ptr= NULL;

	DrawSetSymbol( dbuf, tb->x, tb->y, ptr - 2, tb->attr, FONT_Y );
	WindowDraw( tb->twp, dbuf, 1 );

	if( !(tb->pause ) )	tb->x+= FONT_Y;	/* ̕ʒu */
	return loop;
}

static int	Exec( WindowID wp, EventInfo *info )
{
	TBOX	*tb;
	DrawBuf	dbuf[1];
	int	ret;

	tb= WindowGetClientPointer( wp );

	switch( info->option ){
	case EventInterval:
		if ( IntervalWait( tb->ExecTime, &(tb->work) ) ){
			if( *(tb->ptr) == 0x1a ){	/* EOF */
				if( tb->len ){
					nextline( tb, -2 );
				}
				WindowSetEventAttr( wp, noINTattr );
			}else {
				while( ( ret= charput( tb ) ) > 0 );
				if( ret < 0 ){
					nsnerr( tb->ptr - tb->buf, ret );
					WindowSendSignal( WindowProcessID, SignalKill, 0 );
				}
			}
			return TRUE;
		}
		return FALSE;

	case EventMove:
	case EventPop:
	case EventGraphic:
		return	DefGraphicEnt( &gra, wp, info );

	case EventOpen:		/* clientf[^ݒȂ̂ł߂ */
		DefGraphicInit( &gra, WindowAttrGraphic65536, NULL, NULL );
		WindowSetEventAttr( wp, INTattr );
		WindowSetAttr( wp, WindowAttrGraphic65536 );

						/* OtBbNz[|WV */
	{	int	x, y;
		WindowGetScreenPosition( wp, &x, &y );
		WindowSetGraphicOffset( x, y, OffsetDefaultLevel );
	}
		tone64k( 16 );				/* OtBbNPx */
		return	TRUE;

	case EventRedraw:
									/* OtBbN\ */
	{	ClipClass	clip= { 0, 0, 511, 511 };
		gput( 0, vgram, &clip );
	}
		DefGraphicEnt( &gra, wp, info );

		if( tb->swp ){			/* qXg\Ȃ珑 */
			WindowRedraw( tb->swp );
		}else {
			revive( tb );	/* eLXg\ */
		}
		return	TRUE;

	case EventClose:
		if( tb->swp ){			/* qXg\Ȃ */
			WindowClose( tb->swp );
		}
		WindowClose( wp );
		hisClose( tb );		/* n */
		TxtClose( tb );
		tone64k( 32 );				/* OtBbNPx */
		if( (int)jel )	DBClose( "jel" );
		if( pcmdata.adrs ){
			pcmstop();
			MFREE( (int)(pcmdata.adrs) );
		}
		for( ret= 0; ret < LAYERMAX; ret++ ){
			if( layer[ret].buf )	MFREE( (int)(layer[ret].buf) );
		}
		WindowConnectionClose();	/* vZXI */
		return	TRUE;

	case EventMouseSwitch:
		if( tb->swp ){			/* qXg\ȂCxgn */
			WindowSendEvent( tb->swp, info );
		}else if( info->RightON ){	/* ENbNŃqXg\ */
			TextViewScOpen( tb );
		}else if( info->LeftON && tb->pause > 0 ){
				DrawSetSymbol( dbuf, tb->x, tb->y, "@", tb->attr, FONT_Y );
				WindowDraw( wp, dbuf, 1 );
				tb->attr= tb->pause;
				tb->len= 0;
				tb->pause= -tb->pause;
				return TRUE;
		}else if( info->LeftOFF && tb->pause < 0 ){
				tb->pause= FALSE;
				WindowSetEventAttr( wp, INTattr );
		}
		return TRUE;
	}
	return	FALSE;
}

int	WindowMain( int argc, char **argv )
{
	int	x= 64, y= 0, i;
	char	filename[128]= "start.nsn";
	char	*ptr;

	debug= FALSE;
	lessmem= FALSE;
	PathGetExecDir( path );			/* NpXۑ */
	tbox.lines= 0;
	tbox.max= 128;
	if( !alloc_his( &tbox ) ){
		WindowConnectionClose();
	}
	tbox.swp= NULL;

	argc= AnalyzeArgs( argc, argv, &x, &y, NULL, NULL );
	while( --argc ){
		if( **++argv != '-' ){		/* IvVȊOȂ */
			strcpy( filename, *argv );
		}else if( *(*argv + 1) == 'd' ){
			debug= TRUE;
		}else if( *(*argv + 1) == 'M' ){
			lessmem= TRUE;
		}
	}

	ptr= filename;
	while( *ptr ){
		if( *ptr == '/' ){
			*ptr= '\\';
		}
		ptr++;
	}
	if( ptr= strrchr( filename, '\\' ) ){
		*ptr= NULL;
		strcpy( path, filename );
		strcat( path, "\\" );
		strcpy( filename, ptr + 1 );
	}

	tbox.buf= TxtOpen( filename );
	if( !tbox.buf ){
		hisClose( &tbox );
		WindowConnectionClose();
		return FALSE;
	}

	if( zmusic= zm_check() ){
		zm_init();
	}
	*bgmname= NULL;
	bgopm= FALSE;
	pcmdata.name[0]= NULL;
	pcmdata.adrs= NULL;

	for( i= 0; i < VARMAX; i++ ){
		vartbl[i].name[0]= NULL;
	}
	for( i= 0; i < LAYERMAX; i++ ){
		layer[i].name[0]= NULL;
		layer[i].buf= NULL;
	}
	bgcolor= 0;
	jel= NULL;

	tbox.ptr= tbox.buf;
	tbox.top= 0;
	tbox.x= 0;
	tbox.y= 0;
	tbox.vy= 0;
	tbox.attr= 33;				/* nɔF */
	tbox.ExecTime= 4;			/* `ԊuftHg */
	tbox.echo= FALSE;
	tbox.pause= FALSE;
	tbox.len= 0;
	*(tbox.str)= NULL;
	tbox.twp= WindowTitleOpen( x, y, WIN_H, WIN_V, NULL,
								"nsn", Push|Close, Exec );

	WindowSetClientData( tbox.twp, 0, &tbox );
	WindowRedraw( tbox.twp );
	layman( 2, 0, 0, 0, NULL );	/* GRAMNA */

	return TRUE;
}
